﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace calculate_age
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void dateTimePicker1_CloseUp(object sender, EventArgs e)
        {
            DateTime todays_date, date_of_birth;
            todays_date = DateTime.Today;
            date_of_birth = dtpCurrentDate.Value; 

            TimeSpan date_difference;     
            date_difference = todays_date.Subtract(date_of_birth);


            //AGE_ALGORITHM  :: CA50 @ TE (www.techenclave.com/user/33908-ca50/)
            int total_days = date_difference.Days;
            int calculated_ageYY, calculated_ageMM, calculated_ageDD, remaining_days;
            if ((total_days % 365) == 0)
            {
                calculated_ageYY = total_days / 365;
                calculated_ageMM = 0;
                calculated_ageDD = 0;
            }
            else
            {
                calculated_ageYY = total_days / 365;
                remaining_days = total_days % 365;
                if ((remaining_days % 30) == 0)
                {
                    calculated_ageMM = remaining_days / 30;
                    calculated_ageDD = 0;
                }
                else
                {
                    calculated_ageMM = remaining_days / 30;
                    calculated_ageDD = remaining_days % 30;
                }
            }

            txtYears_ca50_1.Text = calculated_ageYY.ToString();
            txtMonths_ca50_1.Text = calculated_ageMM.ToString();
            txtDays_ca50_1.Text = calculated_ageDD.ToString();

            //AGE_ALGORITHM 2  :: CA50 @ TE (www.techenclave.com/user/33908-ca50/)

            if ((total_days % 365) == 0)
            {
                calculated_ageYY = total_days / 365;
                calculated_ageMM = 0;
                calculated_ageDD = 0;
            }
            else
            {
                calculated_ageYY = total_days / 365;
                remaining_days = total_days % 365;
                remaining_days = remaining_days - 5;
                if ((remaining_days % 30) == 0)
                {
                    calculated_ageMM = remaining_days / 30;
                    calculated_ageDD = 0;
                }
                else
                {
                    calculated_ageMM = remaining_days / 30;
                    calculated_ageDD = remaining_days % 30;
                }
            }

            txtYears_ca50_2.Text = calculated_ageYY.ToString();
            txtMonths_ca50_2.Text = calculated_ageMM.ToString();
            txtDays_ca50_2.Text = calculated_ageDD.ToString();

            //AGE_ALGORITHM 3  :: CA50 @ TE (www.techenclave.com/user/33908-ca50/)

            int year, month, day, month_count = 0, year_count=0;

                int dob_days = date_of_birth.Day;
                int dob_months = date_of_birth.Month;
                int dob_years = date_of_birth.Year;

                int curr_day = todays_date.Day;
                int curr_month = todays_date.Month;
                int curr_year = todays_date.Year;

                year= curr_year-dob_years;
                if (dob_months <= curr_month)
                    month =curr_month-dob_months;
                else
                {
                    month= (curr_month+12)-dob_months;
                     year_count = 1;
                }

                if(dob_days<=curr_day)
                    day=curr_day-dob_days;
                else
                {
                    day = (curr_day+30) - dob_days;
                     month_count = 1;
                }
                year = year - year_count;
                month = month - month_count;

                txtYears_ca50_3.Text = year.ToString();
                txtMonths_ca50_3.Text = month.ToString();
                txtDays_ca50_3.Text = day.ToString();



            //AGE_ALGORITHM  :: luster @ TE (www.techenclave.com/user/14885-luster/)
            int yrDiff = todays_date.Year - date_of_birth.Year;
            int moDiff = todays_date.Month - date_of_birth.Month;
            int daDiff = todays_date.Day - date_of_birth.Day;
            int yrs = 0;
            int mnths = 0;
            int dys = 0;
            if (daDiff >= 0)
            {
                yrs = (yrDiff * 12 + moDiff) / 12;
                mnths = (yrDiff * 12 + moDiff) % 12;
                dys = daDiff;
            }
            else if (daDiff < 0)
            {
                yrs = (yrDiff * 12 + moDiff - 1) / 12;
                mnths = (yrDiff * 12 + moDiff - 1) % 12;
                dys = DateTime.DaysInMonth(date_of_birth.Year, date_of_birth.Month) + daDiff;
            }
            txtYears_luster.Text = yrs.ToString();
            txtMonths_luster.Text = mnths.ToString();
            txtDays_luster.Text = dys.ToString();


            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CenterToScreen();
        }

    }
}
